#include <windows.h>
#include <stdlib.h>
#include <time.h>
#include "registo.h"
#include "resource.h"

static HFILE FilePointer=HFILE_ERROR;
static HFILE FileRecord=HFILE_ERROR;
static long FilePos=-1l;
static long FilePosBak;
static long FilePosRecord=-1l;
static long FilePosBakRecord;

typedef struct t_item
{
	BOOL	estado;
	BOOL	bakestado;
	BOOL	capturado;
	char	valor_sim[10];
	char	valor_nao[10];
	char	nome[20];
	char	HelpFileName[128];
	char	AuthorText[128];
	char	CurrentTime[50];
} ITEM, *ITEMP;

static BOOL Moving;

BOOL FAR PASCAL _export RegisterDataFile( LPCSTR File, LPSTR Source )
{
	HFILE		hf;
	OFSTRUCT	of;

	hf = OpenFile( File, &of, OF_CREATE|OF_READWRITE );
	if ( hf == HFILE_ERROR )
		return FALSE;
	FilePointer = hf;
	FilePos = -1l;
	hf = OpenFile( Source, &of, OF_READ|OF_PROMPT );
	if ( hf == HFILE_ERROR )
		{
		_lclose( FilePointer );
		return FALSE;
		}
	FileRecord = hf;
	FilePosRecord = -1l;
	return TRUE;
}

void FAR PASCAL _export CloseDataFile()
{
	if(FilePointer!=HFILE_ERROR)
		_lclose( FilePointer );
	FilePointer = HFILE_ERROR;
	FilePos = -1l;
	if(FileRecord!=HFILE_ERROR)
		_lclose( FileRecord );
	FileRecord = HFILE_ERROR;
	FilePosRecord = -1l;
}

void FAR PASCAL _export RegisterDataItem(  )
{
	static	char buffer[200];
	char	* s;
	int		i;
	int		j;

	if( FilePointer == HFILE_ERROR )
		return;
	if( FileRecord == HFILE_ERROR )
		lstrcpy( buffer, "NoCliente\t");
	else
		{
		for(s=buffer, j=0;j<(sizeof(buffer)-1);)
			{
			i = _lread( FileRecord, s, 1 );
			if ( i<1 )
				break;
			if (*s =='\r' || *s=='\n' )
				{
				i = _lread( FileRecord, s, 1 );
				if ( i<1 )
					break;
				if (*s =='\r' || *s=='\n' )
					break;
				_llseek( FileRecord, -1l, 1 );
				break;
				}
			s++;
			j++;
			}
		* s ='\0';
		if ( lstrlen(buffer) == 0 )
			{
			MessageBox( GetActiveWindow(), "No More Records", "End Of File", 0 );
			_lclose( FileRecord );
			FileRecord = HFILE_ERROR;
			lstrcpy( buffer, "NoCliente\t");
			}
		}
	for(s=buffer;*s;s++)
		if(*s=='\t')
			{
			*s='\0';
			break;
			}
	if(_llseek( FilePointer, 0l, 2 )!=0l)
		_lwrite( FilePointer, "\r\n[", 3 );
	else
		_lwrite( FilePointer, "[", 1 );
	_lwrite( FilePointer, buffer, lstrlen(buffer) );
	_lwrite( FilePointer, "]\r\n", 3 );
	FilePos = _llseek( FilePointer, 0l, 1 );
}                               

static char line_buffer[40];

PositPointer( char * s )
{
 	long	pos = _llseek( FilePointer, 0l, 1 );
 	char	*p, *k;
 	BOOL	Done = FALSE;
 	long	LineBeg;
 	
    FilePosBak = pos;
    for(;;)
    	{
    	LineBeg = _llseek( FilePointer, 0l, 1 );
		for( k=p=line_buffer;; )
			{
			if(_lread( FilePointer, p, 1 )< 1 )
				{
				Done = TRUE;
				break;      
				}
			if(p-k>=sizeof(line_buffer)-1 )
				break;
			if (*p == '\n')
				break;
			p++;
			}
		*p = '\0';
		for(p=line_buffer, k=s; *k; p++, k++ )
			if( *k!=*p )
				break;
		if ( !*k )
			{           
			_llseek( FilePointer, LineBeg, 0 );
			return TRUE;
			}
		if (Done)
			break;
		}
}

void RegistaValor(ITEMP itemp)
{
	if( FilePointer == HFILE_ERROR || FilePos ==-1l )
		return;
	PositPointer( itemp->nome );
	wsprintf( line_buffer, "%-20s=%-10s\r\n", itemp->nome,
		itemp->estado?itemp->valor_sim:itemp->valor_nao );
	_lwrite( FilePointer, line_buffer, lstrlen( line_buffer ) );
	_llseek( FilePointer, FilePos, 0 );
}

void ParseDados(ITEMP itemp)
{
	char	* s=itemp->AuthorText;
	char	* p = s;  
	char	* q;
	    
	*(itemp->nome)='\0';
	*(itemp->valor_sim)='\0';
	*(itemp->valor_nao)='\0';
	for(;*p;)
		{
		if (*p=='_')
			break;
		p++;
		}
	if(*p)
		{
		for( q = itemp->nome;s<p && (q-itemp->nome)<(20-1);)
			*q++ = *s ++;
		*q='\0';
		}
	s=p+1;
	p++;
	for(;*p;)
		{
		if (*p=='_')
			break;
		p++;
		}
	if(*p)
		{
		for( q = itemp->valor_sim;s<p && (q-itemp->valor_sim)<(10-1);)
			*q++ = *s ++;
		*q='\0';
		}
	s=p+1;
	p++;
	for(;*p;)
		{
		if (*p=='_')
			break;
		p++;
		}
	for( q = itemp->valor_nao;s<p && (q-itemp->valor_nao)<(10-1);)
		*q++ = *s ++;
	*q='\0';
}

void DrawWindowText (HWND hWnd, WORD n)
{
	TEXTMETRIC	tm;
	HLOCAL		hLoc;
	ITEMP		itemp;
	HDC			hdcBits;
	BITMAP		bm;
	HBITMAP		hbm;
	BOOL		f;
	HDC			dc = GetDC( hWnd );

	GetTextMetrics (dc, &tm);
	hLoc = (HLOCAL) n;
	itemp = (ITEMP) LocalLock( hLoc );
	hbm = LoadBitmap( hModule, MAKEINTRESOURCE(itemp->estado ? IDB_BTNON:IDB_BTNOFF));
	hdcBits = CreateCompatibleDC(dc);
	GetObject(hbm,sizeof(BITMAP),(LPSTR)&bm);
	SelectObject(hdcBits,hbm);
	f = BitBlt(dc,0,0,bm.bmWidth,bm.bmHeight,hdcBits,0,0, SRCCOPY);
	DeleteDC(hdcBits);
	DeleteObject( hbm );
	TextOut (dc, 18, 0,itemp->nome, lstrlen (itemp->nome));
	LocalUnlock( hLoc );
	ReleaseDC( hWnd, dc );
}

long FAR PASCAL _export EwSampleProc (HWND hwnd,UINT wMsg,WPARAM wParam,LPARAM lParam)
{
	static HFONT		hfont;
	static TEXTMETRIC	tm;
	static HLOCAL		hLoc;
	static ITEMP		itemp;
	static int			x, y;
	static RECT			rc;

	if(wParam!=WM_CREATE)
		{
		hLoc = GetWindowWord( hwnd, 0 );
		itemp = (ITEMP) LocalLock( hLoc );
		}
	switch (wMsg)
		{
		case WM_CREATE:
			{
			QCI			qci;
			time_t		ttime;

			qci = (QCI)((CREATESTRUCT FAR *)lParam)->lpCreateParams;
			hLoc = LocalAlloc( LHND, sizeof( ITEM ) );
			itemp = (ITEMP)LocalLock( hLoc );
			itemp->estado = FALSE;
			itemp->capturado = FALSE;
			lstrcpy (itemp->HelpFileName, qci->szFileName);
			lstrcpy (itemp->AuthorText, qci->szAuthorData);
			ttime = time (NULL);
			lstrcpy (itemp->CurrentTime, asctime (localtime (&ttime)));
			itemp->CurrentTime[lstrlen (itemp->CurrentTime)-1] = '\0';
			ParseDados( itemp );
    		RegistaValor( itemp );
//			SetWindowLong (hwnd, GWL_STYLE,
//				GetWindowLong (hwnd, GWL_STYLE) | WS_BORDER);
			SetWindowWord( hwnd, 0, (WORD)hLoc );
			LocalUnlock( hLoc );     
			return 0;
			}

		case WM_PAINT :
			{
			PAINTSTRUCT ps;

			BeginPaint (hwnd, &ps);
			DrawWindowText (hwnd, GetWindowWord( hwnd, 0));
			EndPaint (hwnd, &ps);
			LocalUnlock( hLoc );
			return 0;
			}

		case EWM_RENDER :
			{
			switch (wParam)
				{
				case CF_BITMAP :
					{
					RECT rc;
					QRI qri;
					POINT pt;
					HBITMAP hbm, hbmDefault;
					HBRUSH hbrush;
					HDC hdc;

					qri = (QRI)lParam;
					hdc = CreateCompatibleDC (NULL);
					if (hdc != 0)
						{
						hfont = 0;

						SendMessage (hwnd, EWM_QUERYSIZE, (WPARAM)hdc,(LPARAM)&pt);
						rc.left = 0;
						rc.top = 0;
						rc.right = pt.x;
						rc.bottom = pt.y;

						hbm = CreateCompatibleBitmap (qri->hdc, pt.x, pt.y);
						if (hbm != 0)
							{
							hbmDefault = SelectObject (hdc, hbm);
							hbrush = CreateSolidBrush (GetBkColor (hdc));
							if (hbrush != 0)
								{
								FillRect (hdc, &rc, hbrush);
								DeleteObject (hbrush);
								}
							Rectangle (hdc, rc.left, rc.top,rc.right, rc.bottom);
							DrawWindowText (hwnd,GetWindowWord( hwnd, 0));
							hbm = SelectObject (hdc, hbmDefault);
							}
						else
							hbm = NULL;
						DeleteDC (hdc);
						}
					LocalUnlock( hLoc );
					return (long)hbm;
					}

				case CF_TEXT:
					{
					HANDLE gh;
					char * sz;

					gh = GlobalAlloc (GMEM_MOVEABLE | GMEM_NOT_BANKED, 512);
					if (gh != 0)
						{
						sz = GlobalLock (gh);
						wsprintf (sz, "%s%s\r\n",
							((itemp->estado)? "X":" " ),
							itemp->AuthorText);
						GlobalUnlock (gh);
						}
					LocalUnlock( hLoc );
					return (long)gh;
					}

				default :
					LocalUnlock( hLoc );
					return 0;
				}
			}

		case EWM_QUERYSIZE :
			{
			LPPOINT lp;
    
			hfont = SelectObject ((HDC)wParam,GetStockObject (SYSTEM_FONT));
			GetTextMetrics ((HDC)wParam, &tm);
			lp = (LPPOINT)lParam;
			lp->x = 15+LOWORD (GetTextExtent ((HDC)wParam, itemp->nome,
				lstrlen (itemp->nome)));

			lp->x += tm.tmMaxCharWidth;
			lp->y = max( tm.tmHeight + tm.tmExternalLeading, 19 );
			if (hfont)
				SelectObject((HDC)wParam, hfont);
			LocalUnlock( hLoc );
			return 1;
			}
	    case WM_LBUTTONDOWN:
	    	{
	    	HLOCAL		hLoc;
	    	ITEMP		itemp;
	    	
	    	hLoc = (HLOCAL) GetWindowWord( hwnd, 0 );
	    	itemp = (ITEMP) LocalLock( hLoc );
	    	itemp->bakestado = itemp->estado;
	    	itemp->estado = !itemp->estado;
	    	itemp->capturado = TRUE;
	    	SetCapture( hwnd );
			DrawWindowText (hwnd, GetWindowWord( hwnd, 0));
	    	LocalUnlock( hLoc );
	    	return 0;
	    	}
	    case WM_LBUTTONUP:
	    	{
	    	if ( itemp->capturado )
	    		{                  
	    		int x, y;
	    		RECT rc; 
	    		
	    		GetClientRect( hwnd, &rc );
		    	ReleaseCapture(  );
		    	x = LOWORD(lParam);
		    	y = HIWORD( lParam );
		    	if ( !( x>=0 && x<=rc.right && y>=0 && y<=rc.bottom) )
		    		{
		    		if ( itemp->estado!=itemp->bakestado)
		    			{
			    		itemp->estado = !itemp->estado;
						DrawWindowText (hwnd, GetWindowWord( hwnd, 0));
		    			}
		    		}
		    	itemp->capturado = FALSE;
		    	if ( itemp->estado!=itemp->bakestado)
		    		RegistaValor( itemp );
		    	}
	    	}
			LocalUnlock( hLoc );
	    	return 0;
	    case WM_MOUSEMOVE:
	    	{ 
	    	if (!Moving)
	    		{
	    		Moving = TRUE;
		    	if ( itemp->capturado )
		    		{                  
		    		GetClientRect( hwnd, &rc );
			    	x = LOWORD(lParam);
			    	y = HIWORD( lParam );
			    	if ( !( x>=0 && x<=rc.right && y>=0 && y<=rc.bottom) )
			    		{                         
			    		if( itemp->bakestado != itemp->estado )
			    			{
				    		itemp->estado = itemp->bakestado;
							DrawWindowText (hwnd, GetWindowWord( hwnd, 0));
			    			}
			    		}
			    	else
			    		{                         
			    		if( itemp->bakestado == itemp->estado )
			    			{
				    		itemp->estado = !itemp->estado;
							DrawWindowText (hwnd, GetWindowWord( hwnd, 0));
			    			}
			    		}
			    	}
		    	}
		    	Moving = FALSE;
		    }
			LocalUnlock( hLoc );
	    	return 0;

		case WM_DESTROY:
			LocalUnlock( hLoc );
			LocalFree( hLoc );
			return DefWindowProc (hwnd, wMsg, wParam, lParam);
		default :    
			LocalUnlock( hLoc );
			return DefWindowProc (hwnd, wMsg, wParam, lParam);
		}
}


BOOL InitEmbeddedWindow (HANDLE hModule)
{
	WNDCLASS wc;

	wc.lpszClassName = "CheckBoxes";
	wc.style = CS_GLOBALCLASS;
	wc.hCursor = LoadCursor (NULL, IDC_ARROW);
	wc.hIcon = NULL;
	wc.lpszMenuName = NULL;
	wc.hbrBackground = GetStockObject (WHITE_BRUSH);
	wc.hInstance = hModule;
	wc.lpfnWndProc = EwSampleProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 2;

	return RegisterClass (&wc);
}