#include "windows.h"
#include "resource.h"

int PASCAL WinMain(HANDLE, HANDLE, LPSTR, int);
BOOL InitApplication(HANDLE);
BOOL InitInstance(HANDLE, int);
long CALLBACK __export MainWndProc(HWND, UINT, WPARAM, LPARAM);
BOOL __export CALLBACK About(HWND, unsigned, WORD, LONG);
#define AM_AJUDA  WM_USER+1000            // Mensagem para deteco de F1

HANDLE hInst;

/* Funo de entrada para aplicaes windows */

int PASCAL WinMain(hInstance, hPrevInstance, lpCmdLine, nCmdShow)
HANDLE hInstance;
HANDLE hPrevInstance;
LPSTR lpCmdLine;
int nCmdShow;
{
    MSG msg;  

    if (!hPrevInstance)
    if (!InitApplication(hInstance))
        return (FALSE);
        
    if (!InitInstance(hInstance, nCmdShow))
        return (FALSE);
    while (GetMessage(&msg,NULL,NULL,NULL))
    {                              
    /* Caso o utilizador prima F1, emitir para a zona das mensagens da janela activa
      essa informao, de forma a que esta a possa capturar, mesmo que o
      foco esteja em janelas child que no so geridas pela aplicao
    */
      if ( msg.message == WM_KEYDOWN && msg.wParam == VK_F1 )
         PostMessage( GetActiveWindow(), AM_AJUDA, 0, 0 );
      TranslateMessage(&msg);
      DispatchMessage(&msg);
    }
    return (msg.wParam);
}

BOOL InitApplication(hInstance)
HANDLE hInstance;
{
    WNDCLASS  wc;

    /* Definio da classe da janela principal da aplicao */

    wc.style = NULL;
    wc.lpfnWndProc = MainWndProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName =  "menuajuda";
    wc.lpszClassName = "cMainWindow";

    return (RegisterClass(&wc));

}

BOOL InitInstance(hInstance, nCmdShow)
    HANDLE          hInstance;
    int             nCmdShow;
{
    HWND            hWnd;

    hInst = hInstance;

    /* Inicializao desta instncia da aplicao, criando uma janela da classe
      definida anteriormente
    */
      
/*    hWnd = CreateWindow("cMainWindow",
        "Exemplo",WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,
        CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,hInstance,NULL);
    if (!hWnd)
        return (FALSE);
    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);
*/    

    DialogBox(hInst,"AboutBox",GetDesktopWindow(),About);  

    return (TRUE);

}

long CALLBACK __export MainWndProc(hWnd, message, wParam, lParam)
HWND hWnd;
UINT message;
WPARAM wParam;
LPARAM lParam;
{                
   static HWND hActiveChild=NULL;

   /* Procedimento que responde s mensagens para a classe de janelas definida */
   
   switch (message)
      {
      case WM_CREATE:
         /* Criao dos controles */
         CreateWindow( "EDIT", "Hello", WS_CHILD | WS_VISIBLE | WS_BORDER, 50, 30, 200, 25, hWnd,
            IDC_EDIT1, hInst, NULL );
         CreateWindow( "EDIT", "World", WS_CHILD | WS_VISIBLE | WS_BORDER, 50, 80, 200, 25, hWnd,
            IDC_EDIT2, hInst, NULL );
         break;                                                 
      case WM_DESTROY:
         PostQuitMessage(0);
         break;
      case WM_COMMAND:   
         /* Resposta ao click na opo do menu Ajuda */
         
         if (wParam == IDM_ABOUT )
            DialogBox(hInst,"AboutBox",hWnd,About);  
         break;
      case AM_AJUDA:
         {
         int Id;

   /* Respotsa  mensagem de Ajuda */
   
         hActiveChild = GetFocus();       // Para evitar perder o focus
         Id = GetDlgCtrlID( hActiveChild );
         switch(Id)
            {          
            // Se o controle fr um dos que tm Ajuda
            case IDC_EDIT1:
            case IDC_EDIT2:
               WinHelp( hWnd, "help.hlp", HELP_CONTEXT, (DWORD)Id ); 
               // O Id corresponde a 1000 para o primeiro controle e 1001 para o segundo
               break; 
            // Se no existir ajuda particular, chamar a ajuda global
            default:
               WinHelp( hWnd, "help.hlp", HELP_CONTENTS, 0l );
            }
         break;
         }
      case WM_ACTIVATE:
         if (wParam == WA_ACTIVE )
            {        
            // Repor o foco no controle que o perdeu
            if ( hActiveChild != NULL )
               {    
               SetFocus( hActiveChild );
               hActiveChild = NULL;
               }
            }
          break;
      default:
         return (DefWindowProc(hWnd, message, wParam, lParam));  
      }
   return (NULL);
}

BOOL __export CALLBACK About(hDlg, message, wParam, lParam)
HWND hDlg;
unsigned message;
WORD wParam;
LONG lParam;
{
   // Mensagens da Janela de About

   switch (message)
      {
      case WM_INITDIALOG:
         return (TRUE);
      case WM_COMMAND:
         switch(wParam)   
            {
            case IDOK:
            case IDCANCEL:
               EndDialog(hDlg, TRUE);
               return (TRUE);
            case IDM_HELP:
               break;
            default:
               break;
            }
         break;
      }
   return (FALSE);
}