/*
 * DLLXMPL.C -- Help DLL example
 */
#include <windows.h>
#include <stdio.h> 
#include <stdlib.h>
#include <ctl3d.h>
#include "helputil.h"   
#include "resource.h"


/* pointers to WinHelp internal functions */

HANDLE		hModule=NULL;           

BOOL		InitDone=FALSE;

HLOCAL HelpList;
static char HelpFile[80]="";
char		strBuffer[200];
char		IniFile[20]="";

HLOCAL    NewHelpInstance(FARPROC FAR *VPtr)
{
	HelpInstance    *This;
	HLOCAL			hLoc;
	HGLOBAL			hGlob;

	hLoc = LocalAlloc( LHND, sizeof(HelpInstance) );
	This        = (HelpInstance *)LocalLock(hLoc);
	if(This != NULL)
	    {
	    This->Next            = NULL;
	    This->TaskHandle      = GetCurrentTask();
	    This->WinHelp         = (WINHELPPTR)      VPtr[HE_API];
		This->HfsOpenSz       = (LPFN_HFSOPENSZ)  VPtr[HE_HfsOpenSz];
		This->RcCloseHfs      = (LPFN_RCCLOSEHFS) VPtr[HE_RcCloseHfs];
		This->HfOpenHfs       = (LPFN_HFOPENHFS)  VPtr[HE_HfOpenHfs];
		This->RcCloseHf       = (LPFN_RCCLOSEHF)  VPtr[HE_RcCloseHf];
		This->LcbReadHf       = (LPFN_LCBREADHF)  VPtr[HE_LcbReadHf];
		This->LTellHf         = (LPFN_LTELLHF)    VPtr[HE_LTellHf];
		This->LSeekHf         = (LPFN_LSEEKHF)    VPtr[HE_LSeekHf];
		This->FEofHf          = (LPFN_FEOFHF)     VPtr[HE_FEofHf];
		This->LcbSizeHf       = (LPFN_LCBSIZEHF)  VPtr[HE_LcbSizeHf];
		This->FAccessHfs      = (LPFN_FACCESSHFS) VPtr[HE_FAccessHfs];
		This->RcLLInfoFromHf  = (LPFN_RCLLINFOFROMHF)  VPtr[HE_RcLLInfoFromHf];
		This->RcLLInfoFromHfs = (LPFN_RCLLINFOFROMHFS) VPtr[HE_RcLLInfoFromHfs];
		This->ErrorW          = (LPFN_ERRORW)     VPtr[HE_ErrorW];
		This->ErrorSz         = (LPFN_ERRORSZ)    VPtr[HE_ErrorSz];
		This->LGetInfo        = (LPFN_LGETINFO)   VPtr[HE_GetInfo];
		This->FApi            = (LPFN_FAPI)       VPtr[HE_API];
		hGlob = (HGLOBAL)This->LGetInfo( GI_HPATH, NULL );
		lstrcpy( (LPSTR)This->HelpFile, (LPSTR)GlobalLock(hGlob));
		GlobalUnlock( hGlob );
		GlobalFree( hGlob );
		This->_3dEnabled	  = FALSE;
		This->_IsMain	  = FALSE;
		*HelpFile = '\0';
	    if(HelpList)
	        {
	        This->Next  = HelpList;
	        HelpList    = hLoc;
	        }
	    else
	        HelpList    = hLoc;
	    }
	LocalUnlock( hLoc );
	return hLoc;
}

HLOCAL    CurrentHelpInstance(HelpInstance FAR * HelpBuffer)
{
HTASK			ThisTask        = GetCurrentTask();
HLOCAL			Rover = HelpList;
HelpInstance	*This;
HLOCAL			hLoc;

	while(Rover)
		{        
		This = (HelpInstance *) LocalLock( Rover );
		if(This->TaskHandle == ThisTask)
			{                    
			LPSTR s = (LPSTR)This;
			LPSTR t = (LPSTR)HelpBuffer;
			int i;

			if( HelpBuffer!= NULL )			
				for(i=0;i<sizeof(HelpInstance); i++)
					*t++ = *s++;
			LocalUnlock( Rover );
			return Rover;
			}
		else 
			{
			hLoc = Rover;
			Rover   = This->Next;
			LocalUnlock( hLoc );
			}
		}
	return Rover;
}

void UnregisterMe()
{
	HTASK			ThisTask        = GetCurrentTask();
	HLOCAL			Rover = HelpList;
	HelpInstance	*This;
	HLOCAL			hLoc, FirstLoc=NULL;

	while(Rover)
		{        
		This = (HelpInstance *) LocalLock( Rover );
		if(This->TaskHandle == ThisTask)
			{                    
			if( FirstLoc == NULL )
				HelpList = This->Next;
			else
				{
				HelpInstance * Prev = (HelpInstance *)LocalLock( FirstLoc );
				Prev->Next = This->Next;
				LocalUnlock( FirstLoc );
				}
			LocalUnlock( Rover );
			LocalFree( Rover );
			}
		hLoc = Rover;
		Rover   = This->Next;
		FirstLoc = hLoc;
		LocalUnlock( hLoc );
		}
	return;
}

/* HelpYield() - Synchronize winhelp.exe macro execution */
void    HelpYield(void)
{
	MSG     Message;

	while(PeekMessage(&Message, (HWND)NULL, 0, 0, PM_REMOVE))
		{
		if(Message.message == WM_QUIT)
			{
			PostQuitMessage(0);
			return;
			}
		else
			{
			TranslateMessage(&Message);
			DispatchMessage(&Message);
			}
		}
}

BOOL InitGeneralWindow (HANDLE hModule);

int FAR PASCAL LibMain (HINSTANCE hInstance, WORD wDataSeg,
			WORD cbHeap, LPSTR lpchCmdLine)
{       
	HANDLE hMod = hModule;
	extern void FAR PASCAL HUEnable3d( WORD );
	if (cbHeap)
		UnlockData (0);
                    
	hModule = hInstance;
	/* register embedded window classes */
	if (hMod==NULL)
		if (!InitGeneralWindow (hInstance))
			return FALSE;                                      
	hMod = hModule;
	return TRUE;
}

int FAR PASCAL WEP (bSystemExit)
int  bSystemExit;
{
	extern void FAR PASCAL HUEnable3d( WORD );

	bSystemExit = bSystemExit;
	HUEnable3d(FALSE);
	return(1);
}

VOID FAR PASCAL _export HUInitModule(LPSTR s)
{
	if(!InitDone)
		CheckRegistration();
}

VOID FAR PASCAL _export HUIM(LPSTR s)
{
	if(!InitDone)
		CheckRegistration();
	HUInitModule(s);
}

static HelpInstance	HI;

static void _InnerMainClose()
{
	HelpInstance		*ThisHelp = &HI, *This;
	HLOCAL				Rover = HelpList;
	HLOCAL				hLoc;
	static	BOOL		Done = FALSE;	

	if(Done)
		return;
	Done = TRUE;
	if(!InitDone)
		CheckRegistration();
	CurrentHelpInstance(ThisHelp);
	if (!ThisHelp->_IsMain)
		return;
	while(Rover)
		{        

		This = (HelpInstance *) LocalLock( Rover );
		hLoc = Rover;
		Rover   = This->Next;

		if ( ThisHelp->TaskHandle != This->TaskHandle )
			{
			This->WinHelp( This->HelpFile, HELP_QUIT, 0l );
			HelpYield();
			}
		LocalUnlock( hLoc );
		}
}


LONG FAR PASCAL _export LDLLHandler (WORD wMsg,LONG lParam1,LONG lParam2)
{
	static	FILE *EventLog;

	void FAR PASCAL _export HUAutoExtract (LPSTR File);

	switch (wMsg)
	{
	case DW_WHATMSG :
		return (DC_CALLBACKS | DC_ACTIVATE | DC_JUMP |
				DC_MINMAX | DC_INITTERM);

	case DW_CALLBACKS :
		*IniFile='\0';
		NewHelpInstance((FARPROC FAR *)lParam1);
		HUAutoExtract("autoextr.aut");
		return TRUE;

	case DW_ACTIVATE :
		return TRUE;

	case DW_STARTJUMP :
		return TRUE;

	case DW_ENDJUMP :
		{
		void FAR PASCAL _export ExecuteMacro();
		
    	ExecuteMacro();
		}
		return TRUE;

	case DW_CHGFILE :
		return TRUE;

	case DW_MINMAX :
		return TRUE;

	case DW_SIZE :
		return TRUE;

	case DW_INIT :
		return TRUE;

	case DW_TERM :
		{
		void FAR PASCAL CloseTempFont();
		void FAR PASCAL TerminateOnExit();
		
		_InnerMainClose();
		CloseTempFont();
		TerminateOnExit();
		UnregisterMe();
		return TRUE;
		}

	default:
		return TRUE;
	}
}               
