#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include "helputil.h"
#include "bitmap.h"
#include "resource.h"

#define	MAXPROMPT	100
typedef struct t_item
{
	BOOL	estado;
	BOOL	bakestado;
	BOOL	capturado;
} ITEM, *ITEMP;

static BOOL Moving;
static BOOL iniState;
static HWND hWndChild=NULL;

extern VOID ShowBitmapBoth (LPSTR Bitmap, LPSTR Modo, LONG Delay, BOOL Prompt );
static HBITMAP		inicialBitMap=NULL;
static BOOL			TimeDelete = FALSE;
static LONG			TimeDelay=0l;
static char			IniPrompt[MAXPROMPT+1];
static char			b[50], c[50];

VOID FAR PASCAL _export HUShowBitmap ( LPSTR Bitmap, LPSTR Modo, LONG Delay )
{            
	TimeDelete = TRUE;
	ShowBitmapBoth ( Bitmap, Modo, Delay, FALSE );
}

VOID FAR PASCAL _export HUSB ( LPSTR Bitmap, LPSTR Modo, LONG Delay )
{
	HUShowBitmap ( Bitmap, Modo, Delay );
}

VOID FAR PASCAL _export HUShowAbout (LPSTR Bitmap, LPSTR Modo )
{            
	TimeDelete = FALSE;
	ShowBitmapBoth ( Bitmap, Modo, 0l, FALSE );
}

VOID FAR PASCAL _export HUSA (LPSTR Bitmap, LPSTR Modo )
{            
	HUShowAbout ( Bitmap, Modo );
}

VOID FAR PASCAL _export HUShowLogo ( LPSTR Bitmap, LPSTR Modo, LONG Delay, LPSTR Prompt )
{            
	if(lstrlen(Prompt)>MAXPROMPT)
		return;
	lstrcpy( IniPrompt, Prompt );
	TimeDelete = TRUE;
	ShowBitmapBoth ( Bitmap, Modo, Delay, TRUE );
}

VOID FAR PASCAL _export HUSL ( LPSTR Bitmap, LPSTR Modo, LONG Delay, LPSTR Prompt )
{            
	HUShowLogo ( Bitmap, Modo, Delay, Prompt );
}

VOID ShowBitmapBoth (LPSTR Bitmap, LPSTR Modo, LONG Delay, BOOL Prompt )
{
	HANDLE	hanBitmap;
    HWND	hWnd;  
    BITMAP	bm;
    int		screenWidth, screenHeigth;  
    int		x,y;
	static HelpInstance	HI;
	HelpInstance		*ThisHelp = &HI;
	
	if(!InitDone)
		CheckRegistration();
	CurrentHelpInstance(ThisHelp);
	if(Prompt && *IniFile)
		{
		LoadString( hModule, IDS_STARTUPSHOWSECTIONS, b, sizeof(b) );
		LoadString( hModule, IDS_STARTUPSHOWENTRYS, c, sizeof(c) );
		GetPrivateProfileString( b, c, "TRUE", strBuffer, sizeof(strBuffer), IniFile );
		iniState = (!strcmp(strBuffer, "TRUE"));
        if(!iniState)
        	return;
        }
	TimeDelay = Delay;    
	if ( *Modo != 'I' )
		hanBitmap = OpenDIB( Bitmap );
	else
		hanBitmap = OpenInternalDIB( Bitmap );     
	if ( !hanBitmap )
		{
		return;
		}
	inicialBitMap = BitmapFromDib( hanBitmap, NULL );   
    GetObject(inicialBitMap,sizeof(BITMAP),(LPSTR)&bm);
    screenWidth = GetSystemMetrics ( SM_CXSCREEN );
    screenHeigth = GetSystemMetrics ( SM_CYSCREEN );
    x = (screenWidth > bm.bmWidth ) ? (screenWidth - bm.bmWidth ) / 2 : 0;
    y = (screenHeigth > bm.bmHeight ) ? (screenHeigth - bm.bmHeight ) / 2 : 0;
	LoadString( hModule, IDS_SHOWBITMAPCLASS, strBuffer, sizeof(strBuffer) );
	hWnd = CreateWindow( strBuffer, "", WS_POPUP,
		x, y, bm.bmWidth, bm.bmHeight,
		GetActiveWindow(), NULL, hModule, NULL );
	if(Prompt && *IniFile)
		{
		int x;
		HDC hDc = GetDC( hWnd );
		TEXTMETRIC tm;

		LoadString( hModule, IDS_STARTUPSHOWSECTIONS, b, sizeof(b) );
		LoadString( hModule, IDS_STARTUPSHOWENTRYS, c, sizeof(c) );
		GetPrivateProfileString( b, c, "TRUE",
								 strBuffer, sizeof(strBuffer), IniFile );
		iniState = (!strcmp(strBuffer, "TRUE"));
        if(iniState)
        	{
			GetTextMetrics (hDc, &tm);
			x = 15+LOWORD (GetTextExtent (hDc, IniPrompt,
				lstrlen (IniPrompt)));
			x += tm.tmMaxCharWidth;
			ReleaseDC( hWnd, hDc );
			LoadString( hModule, IDS_CHECKBOXCLASSS, b, sizeof(b) );
			hWndChild=CreateWindow( b, IniPrompt, WS_CHILD|WS_VISIBLE|WS_BORDER,
				10, bm.bmHeight-25, x, 17,
				hWnd, 1, hModule, NULL );
			}
		}
	ShowWindow( hWnd, SW_SHOW );
}

long FAR PASCAL _export locWindowProc (HWND hwnd,UINT wMsg,WPARAM wParam,LPARAM lParam)
{

  switch (wMsg)
    {
    case WM_CREATE :
    	if ( TimeDelete )
	    	SetTimer( hwnd, 1, (WORD)TimeDelay, NULL );
    	return 0l;

    case WM_PAINT :
    	{ 
      	PAINTSTRUCT ps;

      	BeginPaint (hwnd, &ps);
      	if (inicialBitMap!=NULL)
      		DrawBitmap( ps.hdc, 0, 0, inicialBitMap, SRCCOPY );
      	EndPaint (hwnd, &ps);
      	return 0;
    	}      
    case WM_TIMER:
    	KillTimer( hwnd, 1 );   
    case WM_KEYDOWN:
    case WM_LBUTTONDOWN:
    case WM_MBUTTONDOWN:
    case WM_RBUTTONDOWN:
    	DestroyWindow( hwnd );
    	return 0; 
//    case WM_ACTIVATE:
//    	if (wParam==WA_INACTIVE && IsWindow( hwnd ) && LOWORD( lParam )!=0)
//    		DestroyWindow( hwnd );
//    	return 0;
    case WM_DESTROY:
      	DeleteObject( inicialBitMap );
      	inicialBitMap = NULL;
      	if(hWndChild!=NULL)
      		{
			LoadString( hModule, IDS_STARTUPSHOWSECTIONS, b, sizeof(b) );
			LoadString( hModule, IDS_STARTUPSHOWENTRYS, c, sizeof(c) );
      		WritePrivateProfileString(b, c,
					 SendMessage(hWndChild,BM_GETCHECK,0,0l)? "TRUE":"FALSE",
					 IniFile );
			}
      	hWndChild = NULL;
		return TRUE;

    default :
      return DefWindowProc (hwnd, wMsg, wParam, lParam);
	}
}


BOOL InitGeneralWindow (HANDLE hModule)
{
  WNDCLASS wc;
  extern long FAR PASCAL _export CheckBoxProc (HWND hwnd,UINT wMsg,
  											WPARAM wParam,LPARAM lParam);
  extern long FAR PASCAL _export CheckBoxProc2 (HWND hwnd,UINT wMsg,
  											WPARAM wParam,LPARAM lParam);
  extern long FAR PASCAL _export procWndMain (HWND hwnd,UINT wMsg,
  											WPARAM wParam,LPARAM lParam);

  LoadString( hModule, IDS_SHOWBITMAPCLASS, strBuffer, sizeof(strBuffer) );
  wc.lpszClassName = strBuffer;
  wc.style = 0;
  wc.hCursor = LoadCursor (NULL, IDC_ARROW);
  wc.hIcon = NULL;
  wc.lpszMenuName = NULL;
  wc.hbrBackground = GetStockObject (WHITE_BRUSH);
  wc.hInstance = hModule;
  wc.lpfnWndProc = locWindowProc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;

  RegisterClass (&wc);

  LoadString( hModule, IDS_CHECKBOXCLASSS, b, sizeof(b) );
  wc.lpszClassName = b;
  wc.style = CS_GLOBALCLASS;
  wc.hCursor = LoadCursor (NULL, IDC_ARROW);
  wc.hIcon = NULL;
  wc.lpszMenuName = NULL;
  wc.hbrBackground = GetStockObject (WHITE_BRUSH);
  wc.hInstance = hModule;
  wc.lpfnWndProc = CheckBoxProc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 2;

  return RegisterClass (&wc);
}

void DrawWindowText (HWND hWnd, WORD n)
{
	TEXTMETRIC	tm;
	HLOCAL		hLoc;
	ITEMP		itemp;
	HDC			hdcBits;
	BITMAP		bm;
	HBITMAP		hbm;
	BOOL		f;
	HDC			dc = GetDC( hWnd );

	GetTextMetrics (dc, &tm);
	hLoc = (HLOCAL) n;
	itemp = (ITEMP) LocalLock( hLoc );
	hbm = LoadBitmap( hModule, MAKEINTRESOURCE(itemp->estado ? IDB_BTNON:IDB_BTNOFF));
	hdcBits = CreateCompatibleDC(dc);
	GetObject(hbm,sizeof(BITMAP),(LPSTR)&bm);
	SelectObject(hdcBits,hbm);
	f = BitBlt(dc,0,0,bm.bmWidth,bm.bmHeight,hdcBits,0,0, SRCCOPY);
	DeleteDC(hdcBits);
	DeleteObject( hbm );
	TextOut (dc, 18, 0,IniPrompt, lstrlen (IniPrompt));
	LocalUnlock( hLoc );
	ReleaseDC( hWnd, dc );
}

long FAR PASCAL _export CheckBoxProc (HWND hwnd,UINT wMsg,WPARAM wParam,LPARAM lParam)
{
	static HFONT		hfont;
	static TEXTMETRIC	tm;
	static HLOCAL		hLoc;
	static ITEMP		itemp;
	static int			x, y;
	static RECT			rc;

	if(wParam!=WM_CREATE)
		{
		hLoc = GetWindowWord( hwnd, 0 );
		itemp = (ITEMP) LocalLock( hLoc );
		}
	switch (wMsg)
		{
		case WM_CREATE:
			{
			QCI			qci;

			qci = (QCI)((CREATESTRUCT FAR *)lParam)->lpCreateParams;
			hLoc = LocalAlloc( LHND, sizeof( ITEM ) );
			itemp = (ITEMP)LocalLock( hLoc );
			itemp->estado = iniState;
			itemp->capturado = FALSE;
			SetWindowWord( hwnd, 0, (WORD)hLoc );
			LocalUnlock( hLoc );     
			return 0;
			}

		case WM_PAINT :
			{
			PAINTSTRUCT ps;

			BeginPaint (hwnd, &ps);
			DrawWindowText (hwnd, GetWindowWord( hwnd, 0));
			EndPaint (hwnd, &ps);
			LocalUnlock( hLoc );
			return 0;
			}

		case EWM_RENDER :
			{
			switch (wParam)
				{
				case CF_BITMAP :
					{
					RECT rc;
					QRI qri;
					POINT pt;
					HBITMAP hbm, hbmDefault;
					HBRUSH hbrush;
					HDC hdc;

					qri = (QRI)lParam;
					hdc = CreateCompatibleDC (NULL);
					if (hdc != 0)
						{
						hfont = 0;

						SendMessage (hwnd, EWM_QUERYSIZE, (WPARAM)hdc,(LPARAM)(&pt));
						rc.left = 0;
						rc.top = 0;
						rc.right = pt.x;
						rc.bottom = pt.y;

						hbm = CreateCompatibleBitmap (qri->hdc, pt.x, pt.y);
						if (hbm != 0)
							{
							hbmDefault = SelectObject (hdc, hbm);
							hbrush = CreateSolidBrush (GetBkColor (hdc));
							if (hbrush != 0)
								{
								FillRect (hdc, &rc, hbrush);
								DeleteObject (hbrush);
								}
							Rectangle (hdc, rc.left, rc.top,rc.right, rc.bottom);
							DrawWindowText (hwnd,GetWindowWord( hwnd, 0));
							hbm = SelectObject (hdc, hbmDefault);
							}
						else
							hbm = NULL;
						DeleteDC (hdc);
						}
					LocalUnlock( hLoc );
					return (long)hbm;
					}

				default :
					LocalUnlock( hLoc );
					return 0;
				}
			}

		case EWM_QUERYSIZE :
			{
			LPPOINT lp;
    
			hfont = SelectObject ((HDC)wParam,GetStockObject (SYSTEM_FONT));
			GetTextMetrics ((HDC)wParam, &tm);
			lp = (LPPOINT)lParam;
			lp->x = 15+LOWORD (GetTextExtent ((HDC)wParam, IniPrompt,
				lstrlen (IniPrompt)));

			lp->x += tm.tmMaxCharWidth;
			lp->y = max( tm.tmHeight + tm.tmExternalLeading, 19 );
			if (hfont)
				SelectObject((HDC)wParam, hfont);
			LocalUnlock( hLoc );
			return 1;
			}
	    case WM_LBUTTONDOWN:
	    	{
	    	HLOCAL		hLoc;
	    	ITEMP		itemp;
	    	
	    	hLoc = (HLOCAL) GetWindowWord( hwnd, 0 );
	    	itemp = (ITEMP) LocalLock( hLoc );
	    	itemp->bakestado = itemp->estado;
	    	itemp->estado = !itemp->estado;
	    	itemp->capturado = TRUE;
	    	SetCapture( hwnd );
			DrawWindowText (hwnd, GetWindowWord( hwnd, 0));
	    	LocalUnlock( hLoc );
	    	return 0;
	    	}
	    case WM_LBUTTONUP:
	    	{
	    	if ( itemp->capturado )
	    		{                  
	    		int x, y;
	    		RECT rc; 
	    		
	    		GetClientRect( hwnd, &rc );
		    	ReleaseCapture(  );
		    	x = LOWORD(lParam);
		    	y = HIWORD( lParam );
		    	if ( !( x>=0 && x<=rc.right && y>=0 && y<=rc.bottom) )
		    		{
		    		if ( itemp->estado!=itemp->bakestado)
		    			{
			    		itemp->estado = !itemp->estado;
						DrawWindowText (hwnd, GetWindowWord( hwnd, 0));
		    			}
		    		}
		    	itemp->capturado = FALSE;
		    	}
	    	}
			LocalUnlock( hLoc );
	    	return 0;
	    case WM_MOUSEMOVE:
	    	{ 
	    	if (!Moving)
	    		{
	    		Moving = TRUE;
		    	if ( itemp->capturado )
		    		{                  
		    		GetClientRect( hwnd, &rc );
			    	x = LOWORD(lParam);
			    	y = HIWORD( lParam );
			    	if ( !( x>=0 && x<=rc.right && y>=0 && y<=rc.bottom) )
			    		{                         
			    		if( itemp->bakestado != itemp->estado )
			    			{
				    		itemp->estado = itemp->bakestado;
							DrawWindowText (hwnd, GetWindowWord( hwnd, 0));
			    			}
			    		}
			    	else
			    		{                         
			    		if( itemp->bakestado == itemp->estado )
			    			{
				    		itemp->estado = !itemp->estado;
							DrawWindowText (hwnd, GetWindowWord( hwnd, 0));
			    			}
			    		}
			    	}
		    	}
		    	Moving = FALSE;
		    }
			LocalUnlock( hLoc );
	    	return 0;
		case BM_GETCHECK:
			{
			BOOL estado=itemp->estado;
			
			LocalUnlock( hLoc );
			return estado;
			}
		case WM_DESTROY:
			LocalUnlock( hLoc );
			LocalFree( hLoc );
			return DefWindowProc (hwnd, wMsg, wParam, lParam);
		default :    
			LocalUnlock( hLoc );
			return DefWindowProc (hwnd, wMsg, wParam, lParam);
		}
}