#include <windows.h>
#include "helputil.h"

void FAR PASCAL _export HUProfileFile( LPSTR File )
{
	if(!InitDone)
		CheckRegistration();
	if(lstrlen(File) < sizeof(IniFile) )
		lstrcpy( IniFile, File );
}

void FAR PASCAL _export HUPF( LPSTR File )
{
	HUProfileFile( File );
}

BOOL FAR PASCAL _export HUSetProfileString( LPSTR Section, LPSTR Entry, LPSTR Value )
{
	return WritePrivateProfileString( Section, Entry, Value, IniFile );
}

BOOL FAR PASCAL _export HUSPS( LPSTR Section, LPSTR Entry, LPSTR Value )
{
	return HUSetProfileString( Section, Entry, Value );
}

BOOL FAR PASCAL _export HUIfProfileString( LPSTR Section, LPSTR Entry, LPSTR Value )
{
	GetPrivateProfileString( Section, Entry, Value,
							 strBuffer, sizeof(strBuffer), IniFile );
	return (!lstrcmp( Value, strBuffer) );
}

BOOL FAR PASCAL _export HUIPS( LPSTR Section, LPSTR Entry, LPSTR Value )
{
	return HUIfProfileString( Section, Entry, Value );
}

void FAR PASCAL _export HUCopyToClipboard( LPSTR String )
{
	static HelpInstance	HI;
	HelpInstance		*ThisHelp = &HI;
	HGLOBAL				hLoc;
	
	if(!InitDone)
		CheckRegistration();
	CurrentHelpInstance(ThisHelp);

	if(!OpenClipboard( (HWND) ThisHelp->LGetInfo( GI_MAINHWND, NULL ) ) )
		return;
	if( !EmptyClipboard() )
		{
		CloseClipboard();
		return;
		}
	hLoc = GlobalAlloc( GHND, lstrlen( String ) + 1);
	lstrcpy( (LPSTR) GlobalLock( hLoc ), String );
	GlobalUnlock( hLoc );
	SetClipboardData( CF_TEXT, hLoc );
	CloseClipboard();
}

void FAR PASCAL _export HUCTC( LPSTR String )
{
	HUCopyToClipboard( String );
}