/*
 * DLLXMPL.C -- Help DLL example
 */
#include <windows.h>
#include <stdio.h> 
#include <stdlib.h>
#include "registo.h"   
#include "resource.h"


/* pointers to WinHelp internal functions */

HANDLE		hModule;           

HLOCAL HelpList;
static char HelpFile[80]="";

HLOCAL    NewHelpInstance(FARPROC FAR *VPtr)
{
	HelpInstance    *This;
	HLOCAL			hLoc;

	hLoc = LocalAlloc( LHND, sizeof(HelpInstance) );
	This        = (HelpInstance *)LocalLock(hLoc);
	if(This != NULL)
	    {
	    This->Next            = NULL;
	    This->TaskHandle      = GetCurrentTask();
	    This->WinHelp         = (WINHELPPTR)      VPtr[HE_API];
		This->HfsOpenSz       = (LPFN_HFSOPENSZ)  VPtr[HE_HfsOpenSz];
		This->RcCloseHfs      = (LPFN_RCCLOSEHFS) VPtr[HE_RcCloseHfs];
		This->HfOpenHfs       = (LPFN_HFOPENHFS)  VPtr[HE_HfOpenHfs];
		This->RcCloseHf       = (LPFN_RCCLOSEHF)  VPtr[HE_RcCloseHf];
		This->LcbReadHf       = (LPFN_LCBREADHF)  VPtr[HE_LcbReadHf];
		This->LTellHf         = (LPFN_LTELLHF)    VPtr[HE_LTellHf];
		This->LSeekHf         = (LPFN_LSEEKHF)    VPtr[HE_LSeekHf];
		This->FEofHf          = (LPFN_FEOFHF)     VPtr[HE_FEofHf];
		This->LcbSizeHf       = (LPFN_LCBSIZEHF)  VPtr[HE_LcbSizeHf];
		This->FAccessHfs      = (LPFN_FACCESSHFS) VPtr[HE_FAccessHfs];
		This->RcLLInfoFromHf  = (LPFN_RCLLINFOFROMHF)  VPtr[HE_RcLLInfoFromHf];
		This->RcLLInfoFromHfs = (LPFN_RCLLINFOFROMHFS) VPtr[HE_RcLLInfoFromHfs];
		This->ErrorW          = (LPFN_ERRORW)     VPtr[HE_ErrorW];
		This->ErrorSz         = (LPFN_ERRORSZ)    VPtr[HE_ErrorSz];
		This->LGetInfo        = (LPFN_LGETINFO)   VPtr[HE_GetInfo];
		This->FApi            = (LPFN_FAPI)       VPtr[HE_API];
		lstrcpy( (LPSTR)This->HelpFile, (LPSTR)HelpFile) ;
		*HelpFile = '\0';
	    if(HelpList)
	        {
	        This->Next  = HelpList;
	        HelpList    = hLoc;
	        }
	    else
	        HelpList    = hLoc;
	    }
	LocalUnlock( hLoc );
	return hLoc;
}

HLOCAL    CurrentHelpInstance(HelpInstance FAR * HelpBuffer)
{
HTASK			ThisTask        = GetCurrentTask();
HLOCAL			Rover = HelpList;
HelpInstance	*This;
HLOCAL			hLoc;

	while(Rover)
		{        
		This = (HelpInstance *) LocalLock( Rover );
		if(This->TaskHandle == ThisTask)
			{                    
			LPSTR s = (LPSTR)This;
			LPSTR t = (LPSTR)HelpBuffer;
			int i;

			if( HelpBuffer!= NULL )			
				for(i=0;i<sizeof(HelpInstance); i++)
					*t++ = *s++;
			LocalUnlock( Rover );
			return Rover;
			}
		else 
			{
			hLoc = Rover;
			Rover   = This->Next;
			LocalUnlock( hLoc );
			}
		}
	return Rover;
}

/* HelpYield() - Synchronize winhelp.exe macro execution */
void    HelpYield(void)
{
	MSG     Message;

	while(PeekMessage(&Message, (HWND)NULL, 0, 0, PM_REMOVE))
		{
		if(Message.message == WM_QUIT)
			{
			PostQuitMessage(0);
			return;
			}
		else
			{
			TranslateMessage(&Message);
			DispatchMessage(&Message);
			}
		}
}

BOOL InitEmbeddedWindow (HANDLE hModule);   

int FAR PASCAL LibMain (HINSTANCE hInstance, WORD wDataSeg,
			WORD cbHeap, LPSTR lpchCmdLine)
{
	if (cbHeap)
		UnlockData (0);
                    
	hModule = hInstance;
	/* register embedded window class */
	if (!InitEmbeddedWindow (hInstance))
		return FALSE;

	return TRUE;
}

VOID FAR PASCAL _export InitModule(LPSTR s)
{
	HelpInstance		*ThisHelp;
	HLOCAL				hLoc;
	
	hLoc = CurrentHelpInstance(NULL);
	ThisHelp = ( HelpInstance * )LocalLock( hLoc );

	lstrcpy( (LPSTR)ThisHelp->HelpFile, s);
	lstrcpy( (LPSTR)HelpFile, s);
	LocalUnlock( hLoc );
}

LONG FAR PASCAL _export LDLLHandler (WORD wMsg,LONG lParam1,LONG lParam2)
{
	static	FILE *EventLog;

	switch (wMsg)
	{
	case DW_WHATMSG :
		return (DC_CALLBACKS | DC_ACTIVATE | DC_JUMP |
				DC_MINMAX | DC_INITTERM);

	case DW_CALLBACKS :
		NewHelpInstance((FARPROC FAR *)lParam1);
		return TRUE;

	case DW_ACTIVATE :
		return TRUE;

	case DW_STARTJUMP :
		return TRUE;

	case DW_ENDJUMP :
		return TRUE;

	case DW_CHGFILE :
		return TRUE;

	case DW_MINMAX :
		return TRUE;

	case DW_SIZE :
		return TRUE;

	case DW_INIT :
		return TRUE;

	case DW_TERM :
		{
		extern void FAR PASCAL _export CloseDataFile();
		extern void FAR PASCAL _export trCloseFile();

		CloseDataFile();
		trCloseFile();
		}
		return TRUE;

	default:
		return TRUE;
	}
}               
