#include <windows.h>
#include <string.h>
#include <dos.h>
#include "commdlg.h"
#include "helputil.h"
#include "resource.h"

BOOL FAR PASCAL __export CustomDlgProc(HWND hwnd, WORD msg, WORD wParam, LONG lParam);

#define	NPOS	5
#define MAXLEN	100

struct
{
	char	title[MAXLEN + 1];
} arr[NPOS];

BOOL	CustomShow = FALSE;

void FAR PASCAL _export HUShowDlg(LPSTR dlgName, LPSTR ResourceFile)
{
    FARPROC		lpfnDlg;
    HANDLE		hMod;

	if( !*ResourceFile )
		hMod = hModule;
	else
		{
		hMod = LoadLibrary( ResourceFile );
		if( hMod == NULL )
			{
			MessageBox( GetActiveWindow(), "A biblioteca em ttulo no foi encontrada", ResourceFile, MB_ICONSTOP );
			return;
			}
		}
    lpfnDlg = MakeProcInstance (CustomDlgProc, hModule);
    if (!lpfnDlg)
		{
		if( hMod!= hModule )
			FreeLibrary( hMod );
	    return;
	    }
	DialogBox( hMod, dlgName, GetActiveWindow(), lpfnDlg );
	FreeProcInstance( lpfnDlg );
	if( hMod!= hModule )
		FreeLibrary( hMod );
}

void FAR PASCAL _export HUSD(LPSTR dlgName, LPSTR ResourceFile)
{
	HUShowDlg(dlgName, ResourceFile);
}

void FAR PASCAL _export HUCustomDialogSetText( LPSTR Texto, WORD Pos )
{
	if ( Pos < NPOS )
		{
		LPSTR s = Texto;
		char *p = arr[Pos].title;
		
		while ( *s && (s-Texto) < MAXLEN )
			*p++ = *s++;
		}
}

void FAR PASCAL _export HUCDST( LPSTR Texto, WORD Pos )
{
	HUCustomDialogSetText( Texto, Pos );
}

void FAR PASCAL _export HUCustomDialogReset( )
{
	int		i;
	
	for( i=0; i< NPOS; i++ )
		arr[i].title[0] = '\0';
}

void FAR PASCAL _export HUCDR( )
{
	HUCustomDialogReset( );
}

void FAR PASCAL _export HUCustomDialogShow( )
{
    FARPROC		lpfnDlg;

    CustomShow = TRUE;
    lpfnDlg = MakeProcInstance (CustomDlgProc, hModule);
    if (!lpfnDlg)
	    return;
	DialogBox( hModule, "CUSTOM", GetActiveWindow(), lpfnDlg );
	FreeProcInstance( lpfnDlg );
    CustomShow = FALSE;
}

void FAR PASCAL _export HUCDS( )
{
	HUCustomDialogShow( );
}

BOOL FAR PASCAL __export CustomDlgProc(HWND hwnd, WORD msg, WORD wParam, LONG lParam)
{
	switch (msg)
		{
		case	WM_INITDIALOG:
			if(CustomShow)
				{
				SetWindowText( hwnd, arr[0].title );
				SetDlgItemText( hwnd, IDC_EDIT1, arr[1].title );
				SetDlgItemText( hwnd, IDC_EDIT2, arr[2].title );
				SetDlgItemText( hwnd, IDC_EDIT3, arr[3].title );
				SetDlgItemText( hwnd, IDC_EDIT4, arr[4].title );
				}
			return 0;
		case	WM_COMMAND:
			if( wParam == IDOK )
				EndDialog( hwnd, TRUE );
			if( wParam == IDCANCEL )
				EndDialog( hwnd, FALSE );
			break;
		default:
			return FALSE;
		}
	return TRUE;
}